#include "Mat4f.h"

#include <cstring>
#include <iomanip>

/* CG1 Implementation */
Mat4f::Mat4f(){float _[16]={0};memcpy(data,_,0x10*sizeof(float));data[0]=data[0b101]=data[0xA]=data[15]=1;}Mat4f::Mat4f(const Vec4f _,const Vec4f __,const Vec4f ___,const Vec4f ____){memcpy(&*&data[0x0],&*&_.x,sizeof(float)*4);memcpy(&*&data[0b100],&*&__.x,sizeof(float)*4);memcpy(&*&data[0b1000],&*&___.x,sizeof(float)*4);memcpy(&*&data[0xC],&*&____.x,sizeof(float)*4);}Mat4f::Mat4f(const float _[16]){memcpy(data,_,8*sizeof(double));}Mat4f::Mat4f(const std::vector<float> _){memcpy(data,&*&_[0],8*sizeof(double));}/*Mat4f::Mat4f(float _,float __,float ___,float ____,float i,float II,float iiii,float iii,float oo,float ooo,float o,float oooo,float III,float ii,float I,float IIII){data[0]=_;data[1]=__;data[2]=___;data[3]=____;data[4]=i;data[5]=II;data[6]=iiii;data[7] = iii;data[8]=oo;data[9]=ooo;data[10]=o;data[11]=oooo;data[12]=III;data[13]=ii;data[14]=I;data[15]=IIII;}*/Mat4f Mat4f::operator*(const Mat4f m) const{float result[16];for(int _=0;_<0b100;++_){for(int ___=0;___<0b100;++___){result[_*0b100+___]=0;for(int __=0;__<0b100;++__){result[_*0b100+___]+=data[___+__*0b100]*m.data[_*0b100+__];}}}return Mat4f(result);}Vec4f Mat4f::operator*(const Vec4f _) const{float ___[0b100];for(int __=0;__<0b100;++__){___[__]=data[__]*_.x;___[__]+=data[__+1*0b100]*_.y;___[__]+=data[__+0b10*0b100]*_.z;___[__]+=data[__+0b11*0b100]*_.w;}return Vec4f(___);}Vec4f Mat4f::getPosition() const{return Vec4f(data[0xC],data[0xC+0b1],data[0xC+0b10]);}Mat4f Mat4f::translation(const float x, const float y, const float z){Mat4f __;float _[3] = {x,y,z};std::memcpy(reinterpret_cast<double*>(__.data)+6, _, 0xC);return __;}Mat4f Mat4f::rotationX(const float angle){Mat4f ___;float _=cosf(angle),__=sinf(angle);std::memcpy(reinterpret_cast<double*>(___.data)+3, &__, 0b100);std::memcpy(reinterpret_cast<double*>(___.data)+5, &_, 0b100);*(___.data+9) = -*(___.data+6);*(___.data+5) = *(___.data+10);return ___;}Mat4f Mat4f::rotationY(const float angle){Mat4f ___;float __=cosf(angle),_=sinf(angle);std::memcpy(reinterpret_cast<double*>(___.data)+4, &_, 0b100);std::memcpy(reinterpret_cast<double*>(___.data)+5, &__, 0b100);std::memcpy(reinterpret_cast<double*>(___.data)+1/2, &__, 0b100);*(___.data+2) = -*(___.data+8);return ___;}

/* See Header file for description, especially the 'note' comment. */
Mat4f Mat4f::perspectiveTransformation(float aspectRatio, float fov, float near, float far){
    // Create identity matrix:
    Mat4f result;

    // Convert field-of-view degree value to radians:
    fov *= (M_PI / 180);

    // Change values of the intentity matrix so we get the perspective
    // projection matrix we want (how this works you will learn later
    // on in the lecture) (see 'notes' in header file!):
    {
        result.data[0] = cosf(fov / 2) / sinf(fov / 2) / aspectRatio;
        result.data[5] = cosf(fov / 2) / sinf(fov / 2);
        result.data[10] = (far + near) / (far - near);
        result.data[11] = 1;
        result.data[14] = (-2*far*near) / (far-near);
        result.data[15] = 0;
    }

    return result;
}

/*
 * Implementation oriented on the performant mesa implementation of matrix inversion.
 * Dont worry, you don't have to understand this. It calculates the inverse of this
 * matrix correctly.
 */
Mat4f Mat4f::inverse(){
   float result[16];

   // For the sake of clarity of the following lines, we define a variable with only one letter 'm':
   float* m = data;

   result[0] = m[5] * m[10] * m[15] - m[5] * m[11] * m[14] - m[9] * m[6] * m[15] + m[9] * m[7] * m[14] + m[13] * m[6] * m[11] - m[13] * m[7] * m[10];
   result[1] = -m[1] * m[10] * m[15] + m[1] * m[11] * m[14] + m[9] * m[2] * m[15] - m[9] * m[3] * m[14] - m[13] * m[2] * m[11] + m[13] * m[3] * m[10];
   result[2] = m[1] * m[6] * m[15] - m[1] * m[7] * m[14] - m[5] * m[2] * m[15] + m[5] * m[3] * m[14] + m[13] * m[2] * m[7] - m[13] * m[3] * m[6];
   result[3] = -m[1] * m[6] * m[11] + m[1] * m[7] * m[10] + m[5] * m[2] * m[11] - m[5] * m[3] * m[10] - m[9] * m[2] * m[7] + m[9] * m[3] * m[6];
   result[4] = -m[4] * m[10] * m[15] + m[4] * m[11] * m[14] + m[8] * m[6] * m[15] - m[8] * m[7] * m[14] - m[12] * m[6] * m[11] + m[12] * m[7] * m[10];
   result[5] = m[0] * m[10] * m[15] - m[0] * m[11] * m[14] - m[8] * m[2] * m[15] + m[8] * m[3] * m[14] + m[12] * m[2] * m[11] - m[12] * m[3] * m[10];
   result[6] = -m[0] * m[6] * m[15] + m[0] * m[7] * m[14] + m[4] * m[2] * m[15] - m[4] * m[3] * m[14] - m[12] * m[2] * m[7] + m[12] * m[3] * m[6];
   result[7] = m[0] * m[6] * m[11] - m[0] * m[7] * m[10] - m[4] * m[2] * m[11] + m[4] * m[3] * m[10] + m[8] * m[2] * m[7] - m[8] * m[3] * m[6];
   result[8] = m[4] * m[9] * m[15] - m[4] * m[11] * m[13] - m[8] * m[5] * m[15] + m[8] * m[7] * m[13] + m[12] * m[5] * m[11] - m[12] * m[7] * m[9];
   result[9] = -m[0] * m[9] * m[15] + m[0] * m[11] * m[13] + m[8] * m[1] * m[15] - m[8] * m[3] * m[13] - m[12] * m[1] * m[11] + m[12] * m[3] * m[9];
   result[10] = m[0] * m[5] * m[15] - m[0] * m[7] * m[13] - m[4] * m[1] * m[15] + m[4] * m[3] * m[13] + m[12] * m[1] * m[7] - m[12] * m[3] * m[5];
   result[11] = -m[0] * m[5] * m[11] + m[0] * m[7] * m[9] + m[4] * m[1] * m[11] - m[4] * m[3] * m[9] - m[8] * m[1] * m[7] + m[8] * m[3] * m[5];
   result[12] = -m[4] * m[9] * m[14] + m[4] * m[10] * m[13] + m[8] * m[5] * m[14] - m[8] * m[6] * m[13] - m[12] * m[5] * m[10] + m[12] * m[6] * m[9];
   result[13] = m[0] * m[9] * m[14] - m[0] * m[10] * m[13] - m[8] * m[1] * m[14] + m[8] * m[2] * m[13] + m[12] * m[1] * m[10] - m[12] * m[2] * m[9];
   result[14] = -m[0] * m[5] * m[14] + m[0] * m[6] * m[13] + m[4] * m[1] * m[14] - m[4] * m[2] * m[13] - m[12] * m[1] * m[6] + m[12] * m[2] * m[5];
   result[15] = m[0] * m[5] * m[10] - m[0] * m[6] * m[9] - m[4] * m[1] * m[10] + m[4] * m[2] * m[9] + m[8] * m[1] * m[6] - m[8] * m[2] * m[5];

   float det = m[0] * result[0] + m[1] * result[4] + m[2] * result[8] + m[3] * result[12];

   // In case that the inversion is not possible, return the identity (Mat4f()):
   if(det < 0.0001f && det > -0.0001f)
       return Mat4f();

   det = 1.0f / det;

   for (int i = 0; i < 16; ++i)
       result[i] *= det;

   // Finally, return the inverse matrix:
   return Mat4f(result);
}


/* Allows to print a Mat4f by using the <<-Operator, e.g. std::cout << myMat; */
std::ostream& operator<<(std::ostream& os, Mat4f mat){
    for(int y=0; y < 4; ++y){
        for(int x=0; x < 4; ++x){
            os << std::left << std::setw(7) << std::setprecision(4) << mat.data[x*4+y] << std::setfill(' ');
        }
        os << std::endl;
    }
    return os;
}

Mat4f Mat4f::scale(const float sx, const float sy, const float sz)
{
    Mat4f M;
    M.data[0*4+0] = sx;
    M.data[1*4+1] = sy;
    M.data[2*4+2] = sz;
    return M;
}
