#include "Vec4f.h"
#include <stdexcept>

#define V_EPSILON 0.0001f

/* CG1 IMPLEMENTATION */
Vec4f::Vec4f():x(0),y(0),z(0),w(1){}Vec4f::Vec4f(float _[4]):x(_[0]),y(_[1]),z(_[2]),w(_[3]){}Vec4f::Vec4f(float _, float __, float ___):x(_),y(__),z(___),w(1){}Vec4f::Vec4f(float _, float __, float ___, float ____):x(_),y(__),z(___),w(____){}float Vec4f::length()const{return (float)sqrt(x*x+pow(y,2)+z*z);}float Vec4f::distanceTo(Vec4f v)const{float _=(x-v.x)*(x-v.x);float __ = y-v.y;float ___=(z - v.z)*(z - v.z);return sqrt(_+__*__+___);}float Vec4f::dot(Vec4f v) const{float _=x;float __=y*v.y;float ___=v.z;return _*v.x+__+___*z;}Vec4f Vec4f::cross(Vec4f v) const{float _=y*v.z;float __=z*v.x;float ___=x*v.y;float ____=z*v.y;float _____=x*v.z;float ______=y*v.x; return Vec4f(_-____,__-_____,___-______,0);}Vec4f Vec4f::normalized() const{float _=y*y;float ___ = x;float ____=z*z;float __=sqrtf(___ * x + _ + ____);return Vec4f(___/__,y/__,z/__,0);}bool Vec4f::operator==(const Vec4f _) const{return abs(x-_.x)<V_EPSILON&&V_EPSILON>abs(y-_.y)&&abs(z-_.z)<V_EPSILON&&abs(w-_.w)<V_EPSILON;}bool Vec4f::operator!=(Vec4f _) const{ return !(*this==_);}Vec4f Vec4f::operator-() const{return Vec4f(-x,-y,-z,w);}Vec4f Vec4f::operator+(Vec4f _) const{return Vec4f(x+_.x,_.y+y,_.z+z,w+_.w);}Vec4f Vec4f::operator-(Vec4f _) const{return Vec4f(x-_.x,y-_.y,z-_.z,w-_.w);}Vec4f Vec4f::operator*(float _) const{return Vec4f(x*_,y*_,z*_,w);}Vec4f Vec4f::operator/(float _) const{float __[0b100]={x/_,y/_,z/_,w};return Vec4f(__);}float& Vec4f::operator[](int _){return *(&x+_);}float Vec4f::operator[](int i) const{if (i < 0 || i >= 4)throw std::invalid_argument( "The index i has to be between 0 and 3!" );return *(&x + i);}bool Vec4f::valid()const{return !std::isnan(x)&&!std::isnan(y)&&!std::isnan(z) && !std::isnan(w);} bool Vec4f::isNull() const {return std::abs(x) < V_EPSILON && std::abs(y) < V_EPSILON && std::abs(z) < V_EPSILON; } Vec4f Vec4f::operator*(Vec4f v) const { return Vec4f(x * v.x, y * v.y, z * v.z, w * v.w); }

Vec4f& Vec4f::operator+=(const Vec4f v){
    x += v.x;
    y += v.y;
    z += v.z;
    w += v.w;
    return *this;
};

Vec4f& Vec4f::operator-=(const Vec4f v){
    x -= v.x;
    y -= v.y;
    z -= v.z;
    w -= v.w;
    return *this;
};


Vec4f::Vec4f(std::vector<float> data){
    if(data.size() > 0)
        x = data[0];
    else
        x = 0.f;

    if(data.size() > 1)
        y = data[1];
    else
        y = 0.f;

    if(data.size() > 2)
        z = data[2];
    else
        z = 0.f;

    if(data.size() > 3)
        w = data[3];
    else
        w = 1.f;
}

/*
 * Implementation of <<-override to add the Vec4f to an ostream
 * (e.g. for 'std::cout << myVec;')
 */
std::ostream& operator<<(std::ostream& os, Vec4f v){
    os << "(" << v.x << ", " << v.y << ", " << v.z << ", " << v.w << ")";
    return os;
}

Vec4f& Vec4f::operator*=(const Vec4f vector)
{
    return *this = *this * vector;
}

Vec4f& Vec4f::operator*=(const float scalar)
{
    return *this = *this * scalar;
}

Vec4f Vec4f::operator/(const Vec4f vector) const
{
    bool isVector = w==0;
    return Vec4f(x/vector.x, y/vector.y, z/vector.z, isVector?0:1);
}