// © 2023, CGVR (https://cgvr.informatik.uni-bremen.de/),
// Author: Andre Mühlenbrock (muehlenb@uni-bremen.de)

#pragma once

#include "src/math/Vec4f.h"

/**
 * Represents a point light source.
 */
class PointLight {
    /** Position of the light in world space */
    Vec4f position;

    /** Color of the light in world space */
    Vec4f color;

public:
    /** Point light */
    PointLight(Vec4f pPosition, Vec4f pColor);

    /** Returns the position */
    Vec4f getPosition(){ return position; }

    /** Returns the light color/power */
    Vec4f getColor(){ return color; }
};
