// © 2023, CGVR (https://cgvr.informatik.uni-bremen.de/),
// Author: Andre Mühlenbrock (muehlenb@uni-bremen.de)

#pragma once

#include "src/scene/Camera.h"
#include "src/scene/PointLight.h"
#include "src/scene/SurfaceList.h"
#include "src/scene/surfaces/Sphere.h"
#include "src/scene/surfaces/Checkerboard.h"

struct Scene {
    /** Camera */
    Camera camera;

    /** Lights */
    std::vector<PointLight> lights;

    /** Surface */
    SurfaceList surfaces;
};
