// © 2023, CGVR (https://cgvr.informatik.uni-bremen.de/),
// Author: Andre Mühlenbrock (muehlenb@uni-bremen.de)

#pragma once

#include "src/scene/Surface.h"

class Checkerboard : public Surface {
    Vec4f normal;
    Vec4f point;

    Vec4f X;
    Vec4f Y;

    Shader shader2;

public:
    Checkerboard(Vec4f pPoint, Vec4f pX, Vec4f pY, Shader pShader, Shader pShader2);

    /** See documentation in parent class 'Surface' */
    virtual Intersection intersect(Ray ray, float tStart, float tEnd) override;

    /** See documentation in parent class 'Surface' */
    virtual Aabb getAabb() const override;
};
