// © 2023, CGVR (https://cgvr.informatik.uni-bremen.de/),
// Author: Andre Mühlenbrock (muehlenb@uni-bremen.de)

#pragma once

#include "src/scene/Surface.h"

class Plane : public Surface {
    Vec4f normal;
    Vec4f point;

public:
    Plane(Vec4f pPoint, Vec4f pNormal, Shader pShader);

    /** See documentation in parent class 'Surface' */
    virtual Intersection intersect(Ray ray, float tStart, float tEnd) override;

    /** See documentation in parent class 'Surface' */
    virtual Aabb getAabb() const override;
};
